﻿using _1037160.NwindDataSetTableAdapters;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Pivot.Core;
using Telerik.Pivot.Core.Aggregates;
using Telerik.WinControls.UI;

namespace _1037160
{
    public partial class Form1 : Form
    {
        RadPivotGrid radPivotGrid1;
        RadChartView radChartView1;

        public Form1()
        {
            InitializeComponent();

            AddPivotGrid();
            AddChartView();

            button1.BringToFront();
        }

        private void AddChartView()
        {
            this.radChartView1 = new RadChartView();
            this.radChartView1.Dock = DockStyle.Bottom;
            this.Controls.Add(this.radChartView1);

            this.radChartView1.DataSource = radPivotGrid1;
        }

        private void AddPivotGrid()
        {
            this.radPivotGrid1 = new RadPivotGrid();
            this.radPivotGrid1.Dock = DockStyle.Fill;
            this.Controls.Add(this.radPivotGrid1);

            this.radPivotGrid1.RowGroupDescriptions.Add(new DateTimeGroupDescription() { PropertyName = "OrderDate", Step = DateTimeStep.Year, GroupComparer = new GroupNameComparer() });
            this.radPivotGrid1.RowGroupDescriptions.Add(new DateTimeGroupDescription() { PropertyName = "OrderDate", Step = DateTimeStep.Quarter, GroupComparer = new GroupNameComparer() });
            this.radPivotGrid1.RowGroupDescriptions.Add(new DateTimeGroupDescription() { PropertyName = "OrderDate", Step = DateTimeStep.Month, GroupComparer = new GroupNameComparer() });
            this.radPivotGrid1.ColumnGroupDescriptions.Add(new PropertyGroupDescription() { PropertyName = "EmployeeID", GroupComparer = new GrandTotalComparer() });
            this.radPivotGrid1.AggregateDescriptions.Add(new PropertyAggregateDescription() { PropertyName = "Freight", AggregateFunction = AggregateFunctions.Sum });
            this.radPivotGrid1.AggregateDescriptions.Add(new PropertyAggregateDescription() { PropertyName = "Freight", AggregateFunction = AggregateFunctions.Average });
            this.radPivotGrid1.FilterDescriptions.Add(new PropertyFilterDescription() { PropertyName = "ShipCountry", CustomName = "Country" });


            NwindDataSet nwindDataSet = new NwindDataSet();
            (new OrdersTableAdapter()).Fill(nwindDataSet.Orders);
            this.radPivotGrid1.AggregatesPosition = PivotAxis.Rows;
            this.radPivotGrid1.DataSource = nwindDataSet.Orders;

            //uncomment for auto update
            //radPivotGrid1.PivotGridElement.DataProvider.StatusChanged += DataProvider_StatusChanged;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            radPivotGrid1.PivotGridElement.SelectAll();
        }
        
        void DataProvider_StatusChanged(object sender, DataProviderStatusChangedEventArgs e)
        {
            if (e.NewStatus == DataProviderStatus.Ready)
            {
                radPivotGrid1.PivotGridElement.SelectAll();
                this.Invoke(new Action(() =>
                    {
                        this.radPivotGrid1.ChartDataProvider.UpdateChartData();
                    }
                )); 
            }
        }
    }
}
